(**************************************************************************************)
(*  'tils Lib - Librairie de composants divers                                        *)
(*  Copyright (C) 2003  U. Van Den Hekke                                              *)
(*                                                                                    *)
(*  This library is free software; you can redistribute it and/or                     *)
(*  modify it under the terms of the GNU Lesser General Public                        *)
(*  License as published by the Free Software Foundation; either                      *)
(*  version 2.1 of the License, or (at your option) any later version.                *)
(*                                                                                    *)
(*  This library is distributed in the hope that it will be useful,                   *)
(*  but WITHOUT ANY WARRANTY; without even the implied warranty of                    *)
(*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU                 *)
(*  Lesser General Public License for more details.                                   *)
(*                                                                                    *)
(*  You should have received a copy of the GNU Lesser General Public                  *)
(*  License along with this library; if not, write to the Free Software               *)
(*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA         *)
(**************************************************************************************)

unit tSysUtils;

interface

uses SysUtils;

{------------------------- On tronque une chaine ------------------------------}
function TruncStr (const s : string; I : Integer) : string;

{-------------------------- Gestion des caractres ----------------------------}
function DownCase (c : char) : char;

{--------------------------- Gestion Rl/String ------------------------------}
function  RealToStr (reel : real;const n : shortInt = 2) : string;
function  StrToReal (S : string) : Real;
procedure IncReal (var R: real; Count : real = 1);
procedure DecReal (var R: real; Count : real = 1);

{---------------------------- Boucle de message -------------------------------}
procedure Delay(tm : Int64);
procedure RunMsg;

implementation

uses Windows;

{------------------------- On tronque une chaine ------------------------------}

function TruncStr (const s : string; I : Integer) : string;
var J : Integer;
begin
  result := '';
  if Length (s) < I then I := Length (s);
  for J := 1 to I do
  Result := Result + S [J];
end;

function DownCase (c : char) : char;
begin
  if c in ['A'..'Z'] then
  c := chr (ord (c) + $20);
  result := c;
end;

function RealToStr (reel : real;const n : shortInt = 2) : string;
begin
  Str (reel:0:n, result);
end;

function StrToReal (S : string) : Real;
var Err : integer;
begin
  Val (S, Result, Err);
  if Err > 0 then val (copy (S, 1, Err - 1), result, Err);
end;

procedure IncReal (var R: real; Count : real = 1);
begin
  R := R + Count;
end;

procedure DecReal (var R: real; Count : real = 1);
begin
  R := R - Count;
end;

{---------------------------- Boucle de message -------------------------------}

procedure RunMsg;
var Msg : tMsg;
begin
  if PeekMessage (msg, 0, 0, 0, pm_Remove)
  then begin
         TranslateMessage (Msg);
         DispatchMessage (Msg);
       end;
end; { RunMsg }

procedure Delay(tm : Int64);
var Time : Int64;
begin
  Time := GetTickCount + Tm;
  while (Time > GetTickCount) do RunMsg;
end; { Delay }

end.

